/* Copyright 2010 Markus Peloquin <markus@cs.wisc.edu>,
 * Lena Olson <lena@cs.wisc.edu>
 *
 * You can't do anything with this but read and execute it privately.  If you
 * want to do more, ask us if we'd be willing to make a more permissive
 * license. */

#ifndef OPENCLK_ERRORS_HPP
#define OPENCLK_ERRORS_HPP

#include <exception>

#include <CL/cl.hpp>

struct Opencl_error : std::exception {
	Opencl_error(cl_int errval);
	Opencl_error(const std::string &msg, cl_int errval);
	virtual ~Opencl_error() throw () {}
	virtual const char *what() const throw ()
	{	return msg.c_str(); }

	std::string	msg;
	cl_int		errval;
};

inline void
opencl_check(cl_int err) throw (Opencl_error)
{
	if (err != CL_SUCCESS) throw Opencl_error(err);
}

inline void
opencl_check(const std::string &msg, cl_int err) throw (Opencl_error)
{
	if (err != CL_SUCCESS) throw Opencl_error(msg, err);
}

#endif
