/* Copyright 2010 Markus Peloquin <markus@cs.wisc.edu>,
 * Lena Olson <lena@cs.wisc.edu>
 *
 * You can't do anything with this but read and execute it privately.  If you
 * want to do more, ask us if we'd be willing to make a more permissive
 * license. */

__kernel void
fib(
    unsigned max_tid,
    __constant unsigned *args,
    __global unsigned *result,
    __global unsigned *spawn,
    __global unsigned *spawn_args)
{
	unsigned tid = get_global_id(0);
	if (tid > max_tid) return;
	unsigned arg = args[tid];

	if (arg < 2) {
		spawn[tid] = false;
		result[tid] = arg;
		return;
	}
	spawn[tid] = true;

	spawn_args += tid * 2;
	spawn_args[0] = arg - 1; /* spawn */
	spawn_args[1] = arg - 2; /* spawn */
	/* sync (always at end) */
}

/* vim: set filetype=c : */
