/* Copyright 2010 Markus Peloquin <markus@cs.wisc.edu>,
 * Lena Olson <lena@cs.wisc.edu>
 *
 * You can't do anything with this but read and execute it privately.  If you
 * want to do more, ask us if we'd be willing to make a more permissive
 * license. */

#ifndef HEAT_H
#define HEAT_H

#define ALLC       0
#define INIT       1
#define COMP       2

#ifdef OPENCLK_HOST

struct heat_ctx {
	cl_float xu, xo, yu, yo, tu, to;
	cl_float dx, dy, dt;

	cl_float dtdxsq, dtdysq;
	cl_float t;

	cl_int nx, ny, nt;
	cl_int leafmaxcol;
};

#else

struct heat_ctx {
	float xu, xo, yu, yo, tu, to;
	float dx, dy, dt;

	float dtdxsq, dtdysq;
	float t;

	int nx, ny, nt;
	int leafmaxcol;
};

#endif

#endif
